/**
 * Author: Valerio Schiavoni <valerio.schiavoni@gmail.com>
 */
package org.objectweb.fractal.bf;

import java.util.logging.Logger;

import org.objectweb.fractal.api.control.BindingController;

/**
 * 
 */
public class ComplexClient implements Runnable, BindingController {

	Logger log = Logger.getLogger(ComplexClient.class.getCanonicalName());
	private ComplexService service;

	/**
	 * @see java.lang.Runnable#run()
	 */
	public void run() {

		final Product product = service.getProduct();
		System.out.println("getProduct: " + product);
		System.out.println("by id (0): " + service.getProductById(0));
		System.out.println("companion: "
				+ service.getCompanionProductOf(product));
		System.out.println("is available: " + service.isAvailable(product));
		System.out.println("the maker is: " + service.makerOf(product));

	}

	// ** BINDING-CONTROLLER IMPL

	/**
	 * See {@link BindingController#listFc()}
	 */
	public String[] listFc() {
		return new String[] { "service" };
	}

	/**
	 * See {@link BindingController#lookupFc(String)}
	 */
	public Object lookupFc(final String cItf) {
		if (cItf.equals("service")) {
			return service;
		}
		return null;
	}

	/**
	 * See {@link BindingController#bindFc(String, Object)}
	 */
	public void bindFc(final String cItf, final Object sItf) {
		if (cItf.equals("service")) {
			service = (ComplexService) sItf;
			return;
		}
	}

	/**
	 * See {@link BindingController#unbindFc(String)}
	 */
	public void unbindFc(final String cItf) {
		if (cItf.equals("service")) {
			service = null;
		}
	}

}
